;Compiler: PureBasic v4.30 Final (x86)
;--- Preparing Start ---
;Various Constants
 #View=#PB_Window_MinimizeGadget ;|#PB_Window_ScreenCentered
 #ProcFlag=#PROCESS_QUERY_INFORMATION|#PROCESS_VM_READ
 #WinWidth=334
 #WinHeight=285
 #Version="Peaks v0.1b"
 #Library=0
 #Deutsch=0
 #English=1
 
Enumeration ; For Gadgets only
 #GUserFrame
 #GSeperator1
 #GSeperator2
 #GShowFrame
 #GUserText1
 #GUserText2
 #GUserText3
 #GUserText4
 #GString1
 #GString2
 #GSpin
 #GOpenButton
 #GStartButton
 #GStopButton
 #GSysText
 #GShowText
 #GColText
 #GValueText
 #GByteText
EndEnumeration

Structure Stuff
  Spinner.w[10]
  SysInfo.s[3] 
  EoL.s[6]
EndStructure

Structure Ware
  Caps.l[2] ;0=CPU, 1=RAM
  Peaks.l[6] ;0..1, 2..3=CPU/RAM Usage-Peaks, 4,5=Current CPU/RAM Usage 
EndStructure

Structure Me
 KeyHandle.l
 KeyPath.s
 Value.l
 ValueType.l
 ValueSize.l
EndStructure

Structure Env
 ProgName.s
 ProgPath.s
 ProgCmd.s
 WorkPath.s
 ProgID.l; Program ID
 PID.l; Process ID
 PHandler.l ;ProcessHandler
 TID.l; Thread ID 
EndStructure

Structure PROCESS_MEMORY_COUNTERS
 cb.l
 PageFaultCount.l
 PeakWorkingSetSize.l
 WorkingSetSize.l
 QuotaPeakPagedPoolUsage.l
 QuotaPagedPoolUsage.l
 QuotaPeakNonPagedPoolUsage.l
 QuotaNonPagedPoolUsage.l
 PagefileUsage.l
 PeakPagefileUsage.l
EndStructure

;"Basic" Variables
Global Event.l, ExtendEvent.l, OLoop.l
;Program-specific Variables
Global InterDef.b, Interval.b, Language.b, ActiveThread.b, FirstRun.b
Global SysText.s, Colon.s, MiniMaxTxt.s, ValueText.s, ByteText.s, Holder.s  
;Dimensioned Variables
Global Dim ErrorMsg.s(6), Dim StatusMsg.s(5), Dim GadgetText.s(8)
;Structured Variables
Global Misc.Stuff, Hard.Ware, Reg.Me, Prog.Env
Global FT_CT.FILETIME, FT_ET.FILETIME;<- Useless, but needed
Global FT_KT.FILETIME, FT_UT.FILETIME ;KernelTime & UserTime 
Global pmc.PROCESS_MEMORY_COUNTERS
;Prototypes
Prototype.l Proto_ProcMem(Process.l,StructAdrPtr.l,StructSize.l)
Declare GadgetControl(GadgetValue.b)
Declare InitStructs()
Declare CreateWindow()
Declare GetProgram()
Declare StartProgram()
Declare StopProgram()
Declare StatusText(State.b)
Declare Guru(Attack.b)
Declare GetHardCaps()
Declare CPU_Usage()
Declare RAM_Usage()
Declare.s FiPrint(Integer.l)
Declare ShowValues()
Declare Thread_RefreshValues(*TimeInterVal)
;Start-up
InitStructs()
CreateWindow()
GetHardCaps()
;--- Preparing End  ---
;-
;--- Main-Loop Start ---
Repeat
 Event=WaitWindowEvent() : ExtendEvent=EventType()
 If Event=#PB_Event_Gadget : GadgetControl(GetGadgetData(EventGadget())) : EndIf 
 If ActiveThread=#True And ProgramRunning(Prog\ProgID)=#False : StopProgram() : EndIf
Until Event=#PB_Event_CloseWindow
If Prog\ProgID<>0 : StopProgram() : EndIf
End
;--- Main-Loop End  --- 
;-
;--------- Start of Master-Functions-----
;
Procedure GadgetControl(GadgetValue.b)
If GadgetValue=0 ;CommandLine-Gadget
 If ExtendEvent=#PB_EventType_Change
   If Len(GetGadgetText(#GString2))>=128
     SetGadgetText(#GString2,Right(GetGadgetText(#GString2),128))
   EndIf
 EndIf
EndIf

If GadgetValue=1 ;Spin-Gadget
 Interval=GetGadgetState(#GSpin)
 SetGadgetText(#GSpin,Str(Misc\Spinner[Interval]))
EndIf

If GadgetValue=2 : GetProgram() : EndIf
If GadgetValue=3 : StartProgram() : EndIf
If GadgetValue=4 : StopProgram() : EndIf
 EndProcedure

Procedure InitStructs()
If OpenLibrary(#Library,"Psapi.dll")
 Global GetMemUsage.Proto_ProcMem=GetFunction(#Library,"GetProcessMemoryInfo")
 Else : Guru(2)
EndIf 
If OpenPreferences("Peaks.ini")
   PreferenceGroup("Global")
   Language=ReadPreferenceLong("Language",0)
   InterDef=ReadPreferenceLong("DInterval",0)
  ClosePreferences()
 Else : Guru(5)
EndIf 
If Language<0 Or Language>1 : Language=0 : EndIf
If InterDef<0 Or InterDef>9 : InterDef=0 : EndIf
Interval=InterDef
Prog\WorkPath="C:\"
Reg\ValueType=#REG_DWORD
Reg\ValueSize=#REG_DWORD
Reg\KeyPath="HARDWARE\DESCRIPTION\System\CentralProcessor\0"
For OLoop=0 To 9 : Misc\Spinner[OLoop]=(OLoop+1)*1000 : Next
For OLoop=0 To 4 : Misc\EoL[OLoop]=Chr(10) : Next
For OLoop=1 To 4 Step 2 : Misc\EoL[OLoop]+Chr(10) : Next 
For OLoop=0 To 5 : Colon+":"+Misc\EoL[OLoop] : Next
StatusMsg(0)=#Version+", 2008 by Burstnibbler"
If Language=#Deutsch : Restore Deutsch : EndIf
If Language=#English : Restore English : EndIf
For OLoop=1 To 5 : Read.s StatusMsg(OLoop) : Next
For OLoop=0 To 6 : Read.s ErrorMsg(OLoop) : Next
For OLoop=0 To 8 : Read.s GadgetText(OLoop) : Next
Restore Universal
For OLoop=0 To 2 : Read.s Holder : Misc\SysInfo[OLoop]+Holder : Next
For OLoop=0 To 3 : Read.s Holder : MiniMaxTxt+Holder+Misc\EoL[OLoop] : Next
Read.s Holder : MiniMaxTxt+Holder+GadgetText(8)+Misc\EoL[4]
Read.s Holder : MiniMaxTxt+Holder+GadgetText(8)+Misc\EoL[5]
For OLoop=0 To 5 : Read.s Holder : ByteText+Holder+Misc\EoL[OLoop] : Next
EndProcedure

Procedure CreateWindow()
If OpenWindow(0,0,0,#WinWidth,#WinHeight,#Version,#View) : Else : Guru(0) : EndIf
If CreateStatusBar(0,WindowID(0)) : Else : Guru(1) : EndIf
 AddStatusBarField(#WinWidth) : StatusText(0)
 Frame3DGadget(#GUserFrame,1,1,#WinWidth-2,80,"",#PB_Frame3D_Single)
 Frame3DGadget(#GSeperator1,0,85,#WinWidth,3,"",#PB_Frame3D_Single)
 Frame3DGadget(#GSeperator2,0,115,#WinWidth,3,"",#PB_Frame3D_Single)
 Frame3DGadget(#GShowFrame,1,140,#WinWidth-2,118,"",#PB_Frame3D_Single)
 TextGadget(#GUserText1,5,8,130,20,GadgetText(0))
 TextGadget(#GUserText2,5,33,130,20,GadgetText(1))
 TextGadget(#GUserText3,5,58,130,20,GadgetText(2))
 TextGadget(#GUserText4,210,58,119,20,GadgetText(3)+Str(Misc\Spinner[InterDef])+" ms",#PB_Text_Center)
 StringGadget(#GString1,145,5,184,20,"",#PB_String_ReadOnly)
 StringGadget(#GString2,145,30,184,20,"")
 SpinGadget(#GSpin,145,55,60,20,0,9,#PB_Spin_ReadOnly) : SetGadgetText(#GSpin,Str(Misc\Spinner[Interval]))
 ButtonGadget(#GOpenButton,7,91,100,20,GadgetText(4))
 ButtonGadget(#GStartButton,117,91,100,20,GadgetText(5))
 ButtonGadget(#GStopButton,227,91,100,20,GadgetText(6))
 TextGadget(#GSysText,5,122,#WinWidth-10,18,"",#PB_Text_Center)
 TextGadget(#GShowText,5,146,100,110,MiniMaxTxt)
 TextGadget(#GColText,106,146,8,110,Colon)
 TextGadget(#GValueText,116,146,120,110,"",#PB_Text_Right)
 TextGadget(#GByteText,250,146,30,110,ByteText)
 SetGadgetColor(#GString2,#PB_Gadget_BackColor,$EFEFEF)
 SetGadgetColor(#GSpin,#PB_Gadget_BackColor,$EFEFEF)
 For OLoop=0 To 4 : SetGadgetData(#GString2+OLoop,OLoop) : Next
 For OLoop=0 To 5 : DisableGadget(#GString1+OLoop,#True) : Next
 DisableGadget(#GOpenButton,#False)
EndProcedure

Procedure GetProgram()
Prog\ProgPath="" : Prog\ProgName="" : SetGadgetText(#GString1,Prog\ProgName)
Prog\ProgCmd="" :  SetGadgetText(#GString2,Prog\ProgCmd)
DisableGadget(#GString2,#True) : DisableGadget(#GSpin,#True)
DisableGadget(#GStartButton,#True) : SetGadgetText(#GValueText,"")
Interval=InterDef : SetGadgetState(#GSpin,Interval)
SetGadgetText(#GSpin,Str(Misc\Spinner[Interval]))
Prog\ProgPath=OpenFileRequester(GadgetText(7),Prog\WorkPath,"Executable (*.exe)|*.exe",0) 
If Prog\ProgPath<>"" And FileSize(Prog\ProgPath)>0
 If CheckFilename(GetFilePart(Prog\ProgPath))   
   Prog\ProgName=GetFilePart(Prog\ProgPath)
   Prog\WorkPath=GetPathPart(Prog\ProgPath)
   SetGadgetText(#GString1,Prog\ProgName)
   For OLoop=0 To 3 : DisableGadget(#GString2+OLoop,#False) : Next
   StatusText(2)
  Else : Guru(4) 
 EndIf
 Else : StatusText(1)
EndIf
EndProcedure

Procedure StartProgram()
For OLoop=0 To 3 : DisableGadget(#GString2+OLoop,#True) : Next
DisableGadget(#GStopButton,#False)
For OLoop=0 To 5 : Hard\Peaks[OLoop]=0 : Next
SetGadgetText(#GValueText,"")
Prog\ProgCmd=GetGadgetText(#GString2)
Prog\ProgID=RunProgram(Prog\ProgPath,Prog\ProgCmd,Prog\WorkPath,#PB_Program_Open)
If Prog\ProgID<>0
 StatusText(4)
 Prog\PID=ProgramID(Prog\ProgID)
 If Prog\PID<>-1
  Prog\PHandler=OpenProcess_(#ProcFlag,#False,Prog\PID)
   If Prog\PHandler<>0
    ActiveThread=#True : FirstRun=0 : StatusText(4) : Delay(250)
    Prog\TID=CreateThread(@Thread_RefreshValues(),Misc\Spinner[Interval])
   EndIf 
 EndIf
 Else : Guru(6)
EndIf 
EndProcedure

Procedure StopProgram()
ActiveThread=#False : DisableGadget(#GStopButton,#True)
If IsThread(Prog\TID)<>0
 While IsThread(Prog\TID)<>0 : Wend
 KillProgram(Prog\ProgID)
 CloseProgram(Prog\ProgID)
EndIf
If Prog\PHandler<>0 : CloseHandle_(Prog\PHandler) : EndIf
Prog\ProgID=0 : StatusText(5)
For OLoop=0 To 3 : DisableGadget(#GString2+OLoop,#False) : Next
EndProcedure

Procedure StatusText(State.b)
StatusBarText(0,0,StatusMsg(State))
EndProcedure

Procedure Guru(Attack.b)
MessageRequester("Guru-Attack!",ErrorMsg(Attack))
If Attack<=2 : End : EndIf 
EndProcedure
;---------- End of Master-Functions ----
;-
;---------- Start of Servant-Functions -
;Servant-Functions = Procedures called by Master-Functions 
Procedure GetHardCaps()
If RegOpenKeyEx_(#HKEY_LOCAL_MACHINE,@Reg\KeyPath,0,#KEY_READ,@Reg\KeyHandle)=0
 If RegQueryValueEx_(Reg\KeyHandle,"~MHz",0,@Reg\ValueType,@Reg\Value,@Reg\ValueSize)=0
  If RegCloseKey_(Reg\KeyHandle)=0
Else : Guru(3)
  EndIf
 EndIf
EndIf
Hard\Caps[0]=Round(Reg\Value/10,#PB_Round_Up)*10
GlobalMemoryStatus_(MemInfo.MEMORYSTATUS)
Hard\Caps[1]=MemInfo\dwTotalPhys + 655360 ; + 640Kb BaseRAM
Hard\Caps[1]=Hard\Caps[1]/1048576 ; /(2*1024)

SysText=Misc\SysInfo[0]+Str(Hard\Caps[0])
SysText+Misc\SysInfo[1]+Str(Hard\Caps[1])+Misc\SysInfo[2]
SetGadgetText(#GSysText,SysText)
EndProcedure

Procedure CPU_Usage()
Protected  NewProcTime.l, NewSysTime.l
Static OldProcTime.l=0, OldSysTime.l=0 
GetProcessTimes_(Prog\PHandler,@FT_CT,@FT_ET,@FT_KT,@FT_UT)
NewProcTime=FT_KT\dwLowDateTime
NewSysTime=GetTickCount_()
If NewSysTime-OldSysTime>0 ; To prevent "Division by Zero"
 Hard\Peaks[4]=((NewProcTime-OldProcTime)/(NewSysTime-OldSysTime))/100
EndIf
OldProcTime=NewProcTime : OldSysTime=NewSysTime
EndProcedure

Procedure RAM_Usage()
GetMemUsage(Prog\PHandler,@pmc,SizeOf(pmc))
Hard\Peaks[5]=pmc\WorkingSetSize
EndProcedure

Procedure.s FiPrint(Integer.l) ;Fi = Formatted Integer
Protected IntString.s=Str(Integer), OutString.s
Protected Pattern.s="###.###.###.###.###.###.###"
Protected SLength.l=Len(IntString), PLength.l=Len(Pattern)
Protected Loop.l, Counter.l, Position.l
For Loop=PLength To 1 Step - 1
 If Mid(Pattern,Loop,1)="#" : Counter+1
  If Counter=SLength : Position=Loop : Counter=1 : Break : EndIf
 EndIf
Next
For Loop=Position To PLength
 If Mid(Pattern,Loop,1)="." : OutString+"."
  Else
    OutString+Mid(IntString,Counter,1) : Counter+1
 EndIf 
Next
ProcedureReturn OutString 
EndProcedure 

Procedure ShowValues()
If Hard\Peaks[4]<0 : Hard\Peaks[4]=0 : EndIf
If Hard\Peaks[4]>100 : Hard\Peaks[4]=100 : EndIf
If FirstRun=0
  Hard\Peaks[2]=Hard\Peaks[5] : Hard\Peaks[0]=Hard\Peaks[4] : FirstRun=1
EndIf
If Hard\Peaks[4]>Hard\Peaks[1] : Hard\Peaks[1]=Hard\Peaks[4] : EndIf
If Hard\Peaks[4]<Hard\Peaks[1] And Hard\Peaks[4]>Hard\Peaks[0] : Hard\Peaks[0]=Hard\Peaks[4] : EndIf
If Hard\Peaks[5]>Hard\Peaks[3] : Hard\Peaks[3]=Hard\Peaks[5] : EndIf
If Hard\Peaks[5]<Hard\Peaks[3] And Hard\Peaks[5]>Hard\Peaks[2]: Hard\Peaks[2]=Hard\Peaks[5] : EndIf
ValueText=""
For OLoop=0 To 5
 ValueText+FiPrint(Hard\Peaks[OLoop])+Misc\EoL[OLoop]
Next
SetGadgetText(#GValueText,ValueText)
EndProcedure

Procedure Thread_RefreshValues(*TimeInterVal) 
While ActiveThread=#True
 CPU_Usage()
 RAM_Usage()
 ShowValues()
 Delay(*TimeInterVal)
Wend
EndProcedure
;----------- End of Servant-Functions - 
;-
;---------- Start of Data-Blocks -----------
DataSection
 Deutsch:
  ;Statusmeldungen
  Data.s "Programm nicht geffnet !", "Programm geffnet", "Programm gestartet"
  Data.s "Programm luft...", "Programm beendet"
  ;Fehlermeldungen
  Data.s "Konnte Fenster nicht ffnen !", "Konnte Statusbar nicht erstellen !"
  Data.s "Konnte <Psapi.dll> nicht finden !", "Konnte nicht auf Registry zugreifen !"
  Data.s "Dateiname enthlt unerlaubte Zeichen !", "<Peaks.ini> nicht gefunden !"
  Data.s  "Programm konnte nicht gestartet werden !"
  ;GadgetTexte
  Data.s "berwachtes Programm", "Kommandozeile (Optional)", "berwachungs-Intervall"
  Data.s "Standard : ", "Programm ffnen", "Programm starten", "Programm beenden"
  Data.s "Programm auswhlen...", "Aktuell"
 English: 
  ;Status-Messages
  Data.s "Program not opened !", "Program opened", "Program started"
  Data.s "Program is running...", "Program terminated"
  ;Error-Messages
  Data.s "Couldnt open a Window !", "Couldnt create a Statusbar !"
  Data.s "Couldnt find <Psapi.dll> !", "Couldnt acces Registry !"
  Data.s "Filename contains forbidden characters !", "<Peaks.ini> not found !"
  Data.s "Unable to start Program !" 
  ;GadgetText
  Data.s "Observed Program", "Command-Line (Optional)", "Surveillance-Interval"
  Data.s "Default : ", "Open Program", "Start Program", "Quit Program"
  Data.s "Choose Program...", "Current"
 Universal:
  Data.s "CPU: ~ ", " MHz,   RAM: ", " MB"
  Data.s "CPU Minimum", "CPU Maximum", "RAM Minimum", "RAM Maximum", "CPU ", "RAM "
  Data.s "%", "%", "Bytes", "Bytes", "%", "Bytes" 
;----------- End of Data-Blocks -----------  
;-
;-EOP  
; IDE Options = PureBasic 4.30 (Windows - x86)
; CursorPosition = 7
; Folding = ---
; EnableThread
; EnableXP
; Executable = Peakz.exe
; DisableDebugger